<?php

class ArrayDataSource extends ItemListActionDataSource
{
 var $d_arr;
 var $d_headers;
 var $d_isSearchable = false;
 var $d_disabled = array( );
 var $d_preSelected = array( );
 
 function ArrayDataSource( $arr, $headers )
 {
 $this->d_arr = $arr;
 $this->d_headers = $headers; 
 }
 
 function setSearchable( $isSearchable )
 {
 $this->d_isSearchable = $isSearchable;
 }
 
 function setItem( $key, $value )
 {
 $this->d_arr[$key] = $value;
 }
 
 function replaceItem( $key, $newValue, $newKey=FALSE )
 {
 $this->d_arr = NodeArrayObject::replace( $this->d_arr, $key, $newValue, $newKey );
 }
 
 function removeItem( $key )
 {
 unset( $this->d_arr[$key] );
 }
 
 function moveItemUp( $key )
 {
 $arr = NodeArrayObject::moveUp( $this->d_arr, $key );
 if ( is_false( $arr ) ) return FALSE;
 $this->d_arr = $arr;
 return TRUE;
 }
 
 function moveItemDown( $key )
 {
 $arr = NodeArrayObject::moveDown( $this->d_arr, $key );
 if ( is_false( $arr ) ) return FALSE;
 $this->d_arr = $arr;
 return TRUE;
 }
 
 function getItems()
 {
 return $this->d_arr;
 }

 function setItems( &$items ) {
 $this->d_arr = $items;
 }
 
 function size()
 {
 return count( $this->d_arr );
 }
 
 function getPlainResultSet( $fromIdx, $toIdx, &$count, $search = "" ) {
 if ( $search != "" )
 {
 $search = strtolower($search);
 $ret = array();
 foreach ( $this->d_arr as $key=>$val )
 {
 foreach ( $val as $such1=>$such2 )
 {
 if ( strpos( strtolower($such1), $search ) !== false || strpos( strtolower($such2), $search ) !== false )
 {
 $ret[] = $this->d_arr[$key];
 break;
 }
 }
 }

 }
 else
 $ret = $this->d_arr; 

 
 $count = count($ret);
 return array_slice($ret, $fromIdx, $toIdx - $fromIdx + 1, true);
 }
 
 function hasColumnHeaders()
 {
 return TRUE;
 }
 
 function getColumns()
 {
 return array_keys( $this->d_headers );
 }
 
 function getColumnHeader( $col )
 {
 return $this->d_headers[$col];
 }

 function isSearchable()
 {
 return $this->d_isSearchable;
 }

 function setCheckboxDisabled( $disabled ) {
 $this->d_disabled = $disabled;
 }
 function isCheckboxDisabled( $id ) {
 return $this->d_disabled[$id];
 }

 function setPreSelected( $preSelected ) {
 $this->d_preSelected = $preSelected;
 }
 function isPreSelected( $id ) {
 return $this->d_preSelected[$id];
 }
}

?>
