<?php











class SQLDatasource extends ItemListActionDataSource
{
 
 var $d_select, $d_from, $d_where, $d_groupby, $d_alwaysOrderBy;
 var $d_db = null;
 var $d_searchFields;
 var $d_sortableFields;
 var $d_sortedCol;
 var $d_sortedWay;
 var $d_columns = array();
 var $d_dbColumns = array();
 var $d_columnAttr = array();
 var $d_isArraySort = false;
 var $d_permTType;
 var $d_permBit;
 var $d_permIdCol;
 var $d_permUserId; 
 var $d_key;
 var $d_searchAble;
 var $d_alwaysSelect;
 var $d_having;
 var $d_filter;
 var $validateSortColumn = true;

 




 function SQLDatasource($key, $select, $from, $where="", $groupby="", $alwaysorderby="", $alwaysSelect='', $having='') 
 {
 $this->d_select = $select;
 $this->d_from = $from;
 $this->d_where = $where;
 $this->d_groupby = $groupby;
 $this->d_key = $key;
 $this->d_alwaysOrderBy = $alwaysorderby;
 $this->d_searchAble = true;
 $this->d_alwaysSelect = $alwaysSelect;
 $this->d_having = $having;
 }

 




 function setSQLDatasourceFilter(&$filter) {
 $this->d_filter = &$filter;
 }

 function getSQLDatasourceFilter() {
 return $this->d_filter;
 }

 function setDBHandle($handle)
 {
 $this->d_db = $handle;
 }

 function setArraySort($isArraySort)
 {
 $this->d_isArraySort = $isArraySort;
 }

 









 function addColumn($col, $header, $isDBColumn=true, $searchable=true, $sortColumn=null)
 {
 if ($searchable === true) {
 $this->d_searchFields[$col] = $col;
 }
 else if ($searchable !== false) {
 $this->d_searchFields[$col] = $searchable;
 }
 
 if ($sortColumn === true) {
 $this->d_sortableFields[$col] = $col;
 }
 else if ($sortColumn != null) {
 $this->d_sortableFields[$col] = $sortColumn;
 }

 $this->d_dbColumns[$col] = $isDBColumn; 
 $this->d_columns[$col] = $header;
 $this->_addColumn( $col, $header );
 }

 





 function setValidateSortColumn($boolean=true) {
 $this->validateSortColumn = $boolean;
 }

 







 function addSearchableColumn($col)
 {
 $this->d_searchFields[$col] = $col;
 }
 
 function removeColumn($col)
 {
 unset( $this->d_searchFields[$col] );
 unset( $this->d_sortableFields[$col] );
 unset( $this->d_columns[$col] );
 }

 function createSearch($cond, $search)
 {
 if ($search) {
 if (is_array($this->d_searchFields)) {

 return " $cond ( " . implode(" LIKE '%$my_search%' OR ", $this->d_searchFields) . 
 " LIKE '%$my_search%' ) ";
 }
 }

 return "";
 }

 function setPermInfo($t_type, $bit, $idCol = '', $userId = 0) {
 global $USER_ID;

 $this->d_permTType = $t_type;
 $this->d_permBit = $bit;

 if ($idCol) {
 $this->d_permIdCol = $idCol;
 }
 else {
 $this->d_permIdCol = 'id';
 }

 if ($userId) {
 $this->d_permUserId = $userId;
 }
 else {
 $this->d_permUserId = $USER_ID;
 }
 }

 function getPlainResultSet($fromIdx, $toIdx, &$count, $search = "", $fetchAll = false) 
 {
 global $DEBUG;
 
 $sortCol = $this->d_sortableFields[$this->d_sortedCol];
 $useArraySort = $this->d_isArraySort && !$this->d_dbColumns[$sortCol];

 
 $csql = "SELECT count(*) as count".($this->d_alwaysSelect?','.$this->d_alwaysSelect:'')." FROM $this->d_from ";
 $sql = "SELECT $this->d_select ";

 if ($this->d_alwaysSelect) {
 $sql .= ','.$this->d_alwaysSelect.' ';
 }

 $sql .= "FROM $this->d_from ";

 if ($this->d_where) {
 $sql .= "WHERE $this->d_where ";
 $csql .= "WHERE $this->d_where ";
 $db_search = $this->createSearch( "AND", $search ); 
 }
 else {
 $db_search = $this->createSearch( "WHERE", $search ); 
 }

 $sql .= $db_search;
 $csql .= $db_search;

 if ($this->d_groupby) {
 $sql .= " GROUP BY $this->d_groupby ";
 $csql .= " GROUP BY $this->d_groupby ";
 }
 
 if ( $this->d_having) {
 $sql .= " HAVING ".$this->d_having.' ';
 $csql .= " HAVING ".$this->d_having.' ';
 }

 if ($sortCol && !$useArraySort) {
 $sortSql = '';
 if ($this->validateSortColumn) {
 $sortSql = sqlf_order_field($sortCol);
 }
 else {
 $sortSql = $sortCol;
 }

 $sql .= "ORDER BY  ".$sortSql." ".sqlf_order_way($this->d_sortedWay)." ";

 if ($this->d_alwaysOrderBy) {
 $sql .= ", ".$this->d_alwaysOrderBy;
 }
 }
 else if ($this->d_alwaysOrderBy) {
 $sql .= "ORDER BY ".$this->d_alwaysOrderBy;
 }

 $rsc = query( $csql, $this->d_db ); 

 if ($this->d_groupby) {
 $count = $rsc["num"];
 }
 else {
 $count = $rsc["arr"][0]["count"];
 }

 
 if ($useArraySort || $fetchAll || $this->d_permTType || isset($this->d_filter)) {
 $limit = 0;
 }
 else {
 $limit = array($fromIdx, $toIdx-$fromIdx+1);
 }

 $rs = query($sql, false, $limit, $this->d_db); 

 if ($DEBUG["sqlds"] ) { 
 echo "sqlds::getResultSet: sql: $sql<br>";
 }

 if ($this->d_permTType) {
 foreach ($rs['arr'] as $row) {
 if (perm($this->d_permUserId, $this->d_permTType , $row[$this->d_permIdCol], $this->d_permBit)) {
 $ret[] = $row;
 } else {
 decho("No perm.<br>", "perm");
 }
 }

 $count = count( $ret );
 }
 else if(isset($this->d_filter)) {

 foreach($rs['arr'] as $row) {
 if( $this->d_filter->checkRow($row)) {
 $ret[] = $row;
 }
 }

 $count = count( $ret );
 } else {
 $ret = $rs["arr"];
 }

 
 
 

 if ((!$fetchAll && $useArraySort) || $this->d_permTType || isset($this->d_filter)) {
 $r = array();
 for ($i = $fromIdx; $i <= $toIdx; $i++) {
 if (isset( $ret[$i])) {
 $r[] = $ret[$i];
 }
 }

 $ret = $r;
 }

 return $ret;
 }

 








 function isPreSelected( $id ) {
 
 }

 function isAllPreSelected() {
 
 }

 



















 function getKey() 
 { 
 return $this->d_key;
 }

 








 function getDefaultItemsPerPageCount() {
 
 }

 function setSearchable($searchable) {
 $this->d_searchAble = $searchable;
 }

 function isSearchable()
 {
 return $this->d_searchAble;
 }
 
 function setSort( $column, $way="ASC" ) 
 { 
 $this->d_sortedCol = $column;
 $this->d_sortedWay = $way;
 }

 function setDefaultSort( $column, $way )
 {
 if (!$this->d_sortedCol) {
 $this->d_sortedCol = $column;
 $this->d_sortedWay = $way;
 }
 }
 
 function getCurrentSort(&$column, &$way) 
 { 
 if (!$this->d_sortedCol) {
 return false;
 }

 $column = $this->d_sortedCol;
 $way = $this->d_sortedWay=="ASC"?0:1;

 return true;
 }
 

 function getSortWays($column) 
 { 
 global $STAG_PREFIX;

 if ($this->d_sortableFields[$column]) {
 return array(
 array("way" => "ASC", "icon" => "$STAG_PREFIX?do=11&module=system&img=sort_asc.gif"), 
 array( "way"=>"DESC", "icon"=>"$STAG_PREFIX?do=11&module=system&img=sort_desc.gif" )
 );
 }

 return null;
 }

 






 function hasColumnHeaders() 
 {
 foreach ($this->d_columns as $head)
 {
 if ($head) {
 return true;
 }
 }

 return false;
 }

 
 function setColumnAttribs($column, $attribs)
 {
 $this->addColumnAttribs($column, $attribs);
 }
}




class SQLDatasourceFilter
{
 



 function checkRow($row) {
 return true;
 }
}




class SQLDatasourcePermFilter extends SQLDatasourceFilter {
 



 function checkRow($row)
 {
 global $USER_ID;
 
 if (perm($USER_ID, T_DATASOURCE, $row["id"], 0)) {
 return $row;
 }
 }
}
